﻿Type=StaticCode
Version=0.1
B4J=true
@EndOfDesignText@

Sub Process_Globals
	Private fx As JFX
End Sub
'Adding Tags to Scene Builder uing a style class TAG:{name}
'This subroutine with extract the Tag and add t to the Nodes Tag field within B4J
'Requires a list of Nodes: For layouts loaded to MainForm.RootPane it is obtainable as 
'
'MainForm.RootPane.GetAllViewsRecursive
Sub ExtractTags(Pane1 As Pane)

	Dim NodeList As List = GetViewsRecursive(Pane1)
	
	For i = 0 To NodeList.Size-1
		Dim N As Node = NodeList.Get(i)
		For Each SC As String In N.StyleClasses
			If SC.ToLowerCase.StartsWith("tag:") Then
				'In anticipation of some objects no having a Tag field put it in a Try/Catch clause
				Try
					N.Tag=SC.SubString(4)
				Catch
					Log("SLUtils ExtractTags : Error assigning Tag to Node :"&N)
				End Try
			End If
		Next
		
	Next

End Sub
Sub GetViewsRecursive(Pane1 As Pane) As List
	Dim Result As List
	Result.Initialize
	For i = 0 To Pane1.NumberOfNodes-1
		Dim N As Node =Pane1.GetNode(i)
		Result.Add(N)
		If N Is Pane Then
			Dim ChildList As List = GetViewsRecursive(N)
			Result.AddAll(ChildList)
		End If
	Next
	Return Result
End Sub
'Find the All Nodes with the same ID as defined in JavaFX SceneBuilder
Sub FindAllNodesFromID(Parent As Node,ID As String) As List
	Dim PA As JavaObject = Parent
	'Convert to List
	Dim NList As List
	Dim JO As JavaObject = PA.RunMethod("lookupAll",Array As Object("#"&ID))
	NList.Initialize
	Dim ReturnType(0) As Object
	Dim TempArr() As Object = JO.RunMethod("toArray",Array As Object(Array As Object(ReturnType)))
	NList.AddAll(TempArr)
	Return NList
End Sub
''Find the All Nodes with the same ID as defined in JavaFX SceneBuilder
'Sub FindAllNodesFromID(Parent As Node,ID As String) As List
'	Dim JO As JavaObject = Parent
'	'Convert to List
'	Dim NList As List
'	NList.Initialize
'	NList.AddAll(JO.RunMethod("lookupAll",Array As Object("#"&ID)))
'	Return NList
'End Sub
Sub GetNodeID (N As Node) As String
	Dim JO As JavaObject = N
	Return JO.RunMethod("getId",Null)
End Sub
